<script lang="ts">
  import {
    Collapse,
    Navbar,
    NavbarToggler,
    NavbarBrand,
    Nav,
    NavItem,
    NavLink,
    Dropdown,
    DropdownToggle,
    DropdownMenu,
    DropdownItem,
  } from '@sveltestrap/sveltestrap';
  import { loginWithRedirect } from '@auth/PermissionRequired.js';
  import { BundleCategoryNames } from '@models/Sandbox.js';
  import { keycloak } from '@stores';

  let isOpen = false;

  function handleUpdate(event) {
    isOpen = event.detail.isOpen;
  }
</script>

<Navbar expand="md" class="custom-navbar">
  <NavbarBrand class="text-white">NCAE Sandbox</NavbarBrand>
  <NavbarToggler on:click={() => (isOpen = !isOpen)} />
  <Collapse {isOpen} navbar expand="md" on:update={handleUpdate}>
    <Nav class="mr-auto" navbar>
      <NavItem>
        <NavLink class="link-underline" href="/">Home</NavLink>
      </NavItem>
      <NavItem>
        <NavLink class="link-underline" href="/challenges">Sandbox Challenges</NavLink>
      </NavItem>
      <!-- TODO add the challenge category links back in once we add categories to the sandbox API -->
      <!--{#each Object.entries(BundleCategoryNames) as [link, name]}-->
      <!--  <NavItem>-->
      <!--    <NavLink class="link-underline" href="/challenges/{link}">{name}</NavLink>-->
      <!--  </NavItem>-->
      <!--{/each}-->
    </Nav>
    <Nav navbar class="ms-auto">
      {#if $keycloak.authenticated}
        <Dropdown nav inNavbar>
          <DropdownToggle nav caret>
            {$keycloak.tokenParsed.name || $keycloak.tokenParsed.email}
          </DropdownToggle>
          <DropdownMenu end>
            <DropdownItem
              class="clickable"
              on:click={() => {
                $keycloak.logout();
              }}>Logout</DropdownItem
            >
          </DropdownMenu>
        </Dropdown>
      {:else}
        <NavItem>
          <NavLink href="javascript:void(0)" on:click={() => $keycloak.login(window.location.href)}>
            Login
          </NavLink>
        </NavItem>
      {/if}
    </Nav>
  </Collapse>
</Navbar>
